/******************************************************
 *  Systemy Mikroprocesorowe w Sterowaniu,  WEiTI PW 	*
 *  STM3210E-EVAL:  PROJEKT_14 wyswietlacz TFT LCD  	*
 ******************************************************/
#include "stm32f10x.h"
#include "stm3210e_eval_lcd.h"
#include <math.h>
#include "foto.h"
#define Brown 0xEBC2
#define Amber 0xFDEA

int  RCC_Config(void);
void GPIO_Config(void);
void Delay(unsigned int);

const float pi = 3.1415629;

int main(void) {
  unsigned int i;
	float x, y, fi;
	
  //konfiguracja systemu --------------------------------------
  RCC_Config();		
  GPIO_Config(); 
  GPIO_ResetBits(GPIOF, GPIO_Pin_6 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9);	// zgasimy wszystkie diody LED
	// inicjalizacja TFT LCD 240320L8
  STM3210E_LCD_Init();
	
	// napis ----------------------------------------------------
		//LCD_SetFont(sFONT *fonts);
  LCD_SetBackColor(Black);		// kolor tla
  LCD_SetTextColor(Amber);   // kolor textu
	LCD_SetFont(&Font16x24);
  LCD_DisplayStringLine(Line0, (uint8_t *)"                    ");
  LCD_DisplayStringLine(Line1, (uint8_t *)"      SYSTEMY       ");
  LCD_DisplayStringLine(Line2, (uint8_t *)"  MIKROPROCESOROWE  ");
  LCD_DisplayStringLine(Line3, (uint8_t *)"    W STEROWANIU    ");
  LCD_DisplayStringLine(Line4, (uint8_t *)"                    ");
  LCD_DisplayStringLine(Line5, (uint8_t *)"    PLUM Ignatki    ");
  LCD_DisplayStringLine(Line6, (uint8_t *)"                    ");
  LCD_DisplayStringLine(Line7, (uint8_t *)"    Politechnika    ");
  LCD_DisplayStringLine(Line8, (uint8_t *)"     Warszawska     ");
  LCD_DisplayStringLine(Line9, (uint8_t *)"                    ");
	Delay(3*8000000);
	
	// kolory ---------------------------------------------------
	LCD_Clear(White);
	LCD_SetBackColor(White);		// kolor tla
  LCD_SetTextColor(Black);   // kolor textu
	LCD_DisplayStringLine(Line4, (uint8_t *)"       White        ");
	Delay(8000000);
	LCD_Clear(Grey);
	LCD_SetBackColor(Grey);
	LCD_DisplayStringLine(Line4, (uint8_t *)"        Grey        ");
	Delay(8000000);
	LCD_Clear(Blue);
	LCD_SetBackColor(Blue);
	LCD_DisplayStringLine(Line4, (uint8_t *)"        Blue        ");
	Delay(8000000);
	LCD_Clear(Blue2);
	LCD_SetBackColor(Blue2);
	LCD_DisplayStringLine(Line4, (uint8_t *)"        Blue2       ");
	Delay(8000000);
	LCD_Clear(Red);
	LCD_SetBackColor(Red);
	LCD_DisplayStringLine(Line4, (uint8_t *)"        Red         ");
	Delay(8000000);
	LCD_Clear(Magenta);
	LCD_SetBackColor(Magenta);
	LCD_DisplayStringLine(Line4, (uint8_t *)"      Magenta       ");
	Delay(8000000);
	LCD_Clear(Green);
	LCD_SetBackColor(Green);
	LCD_DisplayStringLine(Line4, (uint8_t *)"       Green        ");
	Delay(8000000);
	LCD_Clear(Cyan);
	LCD_SetBackColor(Cyan);
	LCD_DisplayStringLine(Line4, (uint8_t *)"        Cyan        ");
	Delay(8000000);
	LCD_Clear(Yellow);
	LCD_SetBackColor(Yellow);
	LCD_DisplayStringLine(Line4, (uint8_t *)"       Yellow       ");
	Delay(8000000);
	LCD_Clear(Brown);
	LCD_SetBackColor(Brown);
	LCD_DisplayStringLine(Line4, (uint8_t *)"       Brown        ");
	Delay(8000000);
	
	// grafika 1 ------------------------------------------------
	loop:
	LCD_Clear(Black);		// Clear the LCD
	LCD_SetTextColor(Yellow);   // kolor textu
	LCD_DrawCircle(120, 160, 110);
	for(fi=0; fi<2*pi; fi += pi/30) {
		LCD_SetTextColor(Red);   // kolor textu
		x = cos(fi); y = sin(fi);
		LCD_DrawUniLine(120, 160, 120 - (int)(80*x), 160 - (int)(80*y));
		LCD_SetTextColor(White);   // kolor textu
		LCD_DrawUniLine(120 - (int)(80*x), 160 - (int)(80*y), 120 - (int)(100*x), 160 - (int)(100*y));
		Delay(800000);
	}
	Delay(8000000);
	LCD_Clear(Black);		// Clear the LCD
	LCD_SetTextColor(Yellow);   // kolor textu
	LCD_DrawCircle(120, 160, 110);
	for(fi=0; fi<2*pi; fi += pi/30) {
		LCD_SetTextColor(Red);   // kolor textu
		x = cos(fi); y = sin(fi);
		LCD_DrawUniLine(120, 160, 120 - (int)(80*x), 160 - (int)(80*y));
		LCD_SetTextColor(White);   // kolor textu
		LCD_DrawUniLine(120 - (int)(80*x), 160 - (int)(80*y), 120 - (int)(100*x), 160 - (int)(100*y));
		Delay(800000);
		LCD_SetTextColor(Black);   // kolor textu
		LCD_DrawUniLine(120, 160, 120 - (int)(80*x), 160 - (int)(80*y));
	}
	LCD_SetTextColor(Yellow);
	LCD_DrawUniLine(120, 160, 120 - (int)x, 160 - (int)y);
	Delay(8000000);
	LCD_Clear(Black);		// Clear the LCD
	
	// obrazki ---------------------------------------------------
	for(i=0; i<3; i++) {
		switch(i) {
			case 0: LCD_WriteBMP((uint32_t)surykatka);				// FedericaNargi | surykatka | acfoto1 | acAdaMichal
				break;
			case 1: LCD_WriteBMP((uint32_t)Jamie);						// Jamie | chomik | acksiazka | acksiazka
				break;
			case 2: LCD_WriteBMP((uint32_t)chomik);						// zachod | foto | acplaza | acFedericaNargi2
		}
		GPIO_WriteBit(GPIOF, GPIO_Pin_6, Bit_SET);
		Delay(4000000);
		GPIO_WriteBit(GPIOF, GPIO_Pin_6, Bit_RESET);
		GPIO_WriteBit(GPIOF, GPIO_Pin_7, Bit_SET);
		Delay(4000000);
		GPIO_WriteBit(GPIOF, GPIO_Pin_7, Bit_RESET);
		GPIO_WriteBit(GPIOF, GPIO_Pin_8, Bit_SET);
		Delay(4000000);
		GPIO_WriteBit(GPIOF, GPIO_Pin_8, Bit_RESET);
		GPIO_WriteBit(GPIOF, GPIO_Pin_9, Bit_SET);
		Delay(4000000);
		GPIO_WriteBit(GPIOF, GPIO_Pin_9, Bit_RESET);
		GPIO_WriteBit(GPIOF, GPIO_Pin_8, Bit_SET);
		Delay(4000000);
		GPIO_WriteBit(GPIOF, GPIO_Pin_8, Bit_RESET);
		GPIO_WriteBit(GPIOF, GPIO_Pin_7, Bit_SET);
		Delay(4000000);
		GPIO_WriteBit(GPIOF, GPIO_Pin_7, Bit_RESET);
  }
	goto loop;
//  return 0;  // tego 'return' nigdy nie osiagnie 
}
//------------ konfiguracja RCC: sygnaly taktujace ------------
int RCC_Config(void) {
  ErrorStatus HSEStartUpStatus;                          // zmienna opisujaca rezultat uruchomienia HSE

  RCC_DeInit();                                          // RCC na 'default reset state'
  RCC_HSEConfig(RCC_HSE_ON);                             // wlacz HSE
  HSEStartUpStatus = RCC_WaitForHSEStartUp();            // czekaj na gotowosc HSE
  if(HSEStartUpStatus == SUCCESS) {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);//
    FLASH_SetLatency(FLASH_Latency_2);                   // zwloka Flasha: 2 takty dla 72MHz
    RCC_HCLKConfig(RCC_SYSCLK_Div1);                     // HCLK=SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);                      // PCLK2=HCLK
    RCC_PCLK1Config(RCC_HCLK_Div2);                      // PCLK1=HCLK/2
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); // PLLCLK = HSE*9 czyli 8MHz * 9 = 72 MHz
    RCC_PLLCmd(ENABLE);                                  // wlacz PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);  // czekaj na uruchomienie PLL
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);           // ustaw PLL jako zrodlo sygnalu zegarowego
    while(RCC_GetSYSCLKSource() != 0x08);                // czekaj az PLL bedzie sygnalem zegarowym systemu
// konfiguracja sygnalow taktujacych uzywanych peryferii 
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOF, ENABLE);// wlacz taktowanie portu GPIO F
		return 0;
  }
	else
		return 1;
}
//------------------ konfiguracja portow GPIO -----------------
void GPIO_Config(void) {
  GPIO_InitTypeDef  GPIO_InitStructure; 

  /*Tu nalezy umiescic kod zwiazany z konfiguracja poszczegolnych portow GPIO potrzebnych w programie*/
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      // wyjscie w trybie push-pull
  GPIO_Init(GPIOF, &GPIO_InitStructure);
	
}

void Delay(unsigned int counter){
	// opoznienie programowe, 8'000'000 to jedna sekunda
	while (counter--){
		__NOP();
		__NOP();
	}
}





